(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('i18n-iso-countries'), require('@angular/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-i18n-country-select', ['exports', '@angular/core', 'i18n-iso-countries', '@angular/forms', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["ngx-i18n-country-select"] = {}, global.ng.core, global.i18nIsoCountries, global.ng.forms, global.ng.common));
})(this, (function (exports, i0, i18nIsoCountries, i2, i3) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var I18nCountrySelectService = /** @class */ (function () {
        function I18nCountrySelectService(localeId, errorHandler) {
            this.localeId = localeId;
            this.errorHandler = errorHandler;
            this.localeIds = ['en'];
        }
        I18nCountrySelectService.prototype.use = function (localeIds) {
            return __awaiter(this, void 0, void 0, function () {
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            this.localeIds = __spreadArray([], __read(localeIds));
                            return [4 /*yield*/, Promise.all(this.localeIds.map(function (localeId) { return __awaiter(_this, void 0, void 0, function () {
                                    var locale, error_1;
                                    return __generator(this, function (_a) {
                                        switch (_a.label) {
                                            case 0:
                                                _a.trys.push([0, 2, , 3]);
                                                return [4 /*yield*/, import("i18n-iso-countries/langs/" + localeId + ".json")];
                                            case 1:
                                                locale = _a.sent();
                                                i18nIsoCountries.registerLocale(locale);
                                                return [3 /*break*/, 3];
                                            case 2:
                                                error_1 = _a.sent();
                                                this.errorHandler.handleError(error_1);
                                                return [3 /*break*/, 3];
                                            case 3: return [2 /*return*/];
                                        }
                                    });
                                }); }))];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        I18nCountrySelectService.prototype.loadCountries = function () {
            return Object.entries(i18nIsoCountries.getNames(this.getLocale()))
                .map(function (_a) {
                var _b = __read(_a, 2), key = _b[0], value = _b[1];
                return [key, Array.isArray(value) ? value[0] : value];
            })
                .sort(function (a, b) { return a[1].localeCompare(b[1]); })
                .map(function (country) { return ({ display: country[1], value: country[0].toLowerCase() }); });
        };
        I18nCountrySelectService.prototype.getLocale = function () {
            var locale;
            if (this.localeId.length > 2) {
                // convert Locale from ISO 3166-2 to ISO 3166 alpha2
                locale = this.localeId.toLowerCase().slice(0, 2);
            }
            else {
                locale = this.localeId.toLowerCase();
            }
            // return locale only if loaded else first available
            if (this.localeIds.indexOf(locale) > -1) {
                return locale;
            }
            else {
                return this.localeIds[0];
            }
        };
        return I18nCountrySelectService;
    }());
    I18nCountrySelectService.ɵfac = function I18nCountrySelectService_Factory(t) { return new (t || I18nCountrySelectService)(i0__namespace.ɵɵinject(i0.LOCALE_ID), i0__namespace.ɵɵinject(i0__namespace.ErrorHandler)); };
    I18nCountrySelectService.ɵprov = /*@__PURE__*/ i0__namespace.ɵɵdefineInjectable({ token: I18nCountrySelectService, factory: I18nCountrySelectService.ɵfac, providedIn: 'root' });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(I18nCountrySelectService, [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root',
                    }]
            }], function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [i0.LOCALE_ID]
                        }] }, { type: i0__namespace.ErrorHandler }];
        }, null);
    })();

    /* eslint-disable @angular-eslint/component-selector */
    function I18nCountrySelectComponent_option_3_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "option", 1);
            i0__namespace.ɵɵtext(1);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var country_r1 = ctx.$implicit;
            i0__namespace.ɵɵproperty("ngValue", country_r1.value);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵtextInterpolate(country_r1.display);
        }
    }
    var I18nCountrySelectComponent = /** @class */ (function () {
        function I18nCountrySelectComponent(cdRef, el, renderer, service) {
            this.cdRef = cdRef;
            this.el = el;
            this.renderer = renderer;
            this.service = service;
            this.name = 'I18nCountrySelect';
            this.pleaseChoose = 'Please choose...';
            this.editable = true;
            this.mandatory = false;
            this.iso3166Alpha2Change = new i0.EventEmitter();
            this.items = [];
            this.items = this.service.loadCountries();
            this.defaultLabel = this.pleaseChoose;
        }
        I18nCountrySelectComponent.prototype.change = function (newValue) {
            this.iso3166Alpha2 = newValue;
            this.iso3166Alpha2Change.emit(newValue);
        };
        I18nCountrySelectComponent.prototype.ngAfterViewChecked = function () {
            var select = this.el.nativeElement.querySelector('select');
            if (this.iso3166Alpha2) {
                this.iso3166Alpha2 = this.iso3166Alpha2.toLowerCase();
            }
            if (this.mandatory) {
                this.renderer.setAttribute(select, 'required', '');
            }
            this.cdRef.detectChanges(); // avoid ExpressionChangedAfterItHasBeenCheckedError
        };
        return I18nCountrySelectComponent;
    }());
    I18nCountrySelectComponent.ɵfac = function I18nCountrySelectComponent_Factory(t) { return new (t || I18nCountrySelectComponent)(i0__namespace.ɵɵdirectiveInject(i0__namespace.ChangeDetectorRef), i0__namespace.ɵɵdirectiveInject(i0__namespace.ElementRef), i0__namespace.ɵɵdirectiveInject(i0__namespace.Renderer2), i0__namespace.ɵɵdirectiveInject(I18nCountrySelectService)); };
    I18nCountrySelectComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: I18nCountrySelectComponent, selectors: [["i18n-country-select"]], inputs: { name: "name", iso3166Alpha2: "iso3166Alpha2", size: "size", pleaseChoose: "pleaseChoose", editable: "editable", mandatory: "mandatory" }, outputs: { iso3166Alpha2Change: "iso3166Alpha2Change" }, decls: 4, vars: 9, consts: [[3, "name", "id", "ngModel", "disabled", "ngModelChange"], [3, "ngValue"], [3, "ngValue", 4, "ngFor", "ngForOf"]], template: function I18nCountrySelectComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵelementStart(0, "select", 0);
                i0__namespace.ɵɵlistener("ngModelChange", function I18nCountrySelectComponent_Template_select_ngModelChange_0_listener($event) { return ctx.change($event); });
                i0__namespace.ɵɵelementStart(1, "option", 1);
                i0__namespace.ɵɵtext(2);
                i0__namespace.ɵɵelementEnd();
                i0__namespace.ɵɵtemplate(3, I18nCountrySelectComponent_option_3_Template, 2, 2, "option", 2);
                i0__namespace.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0__namespace.ɵɵclassMap("form-control" + (ctx.size ? " form-control-" + ctx.size : ""));
                i0__namespace.ɵɵproperty("name", ctx.name)("id", ctx.name)("ngModel", ctx.iso3166Alpha2)("disabled", !ctx.editable);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngValue", null);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵtextInterpolate(ctx.defaultLabel);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngForOf", ctx.items);
            }
        }, directives: [i2__namespace.SelectControlValueAccessor, i2__namespace.NgControlStatus, i2__namespace.NgModel, i2__namespace.NgSelectOption, i2__namespace.ɵNgSelectMultipleOption, i3__namespace.NgForOf], encapsulation: 2, changeDetection: 0 });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(I18nCountrySelectComponent, [{
                type: i0.Component,
                args: [{
                        selector: 'i18n-country-select',
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        template: "\n    <select\n      [name]=\"name\"\n      [id]=\"name\"\n      [class]=\"'form-control' + (size ? ' form-control-' + size : '')\"\n      [ngModel]=\"iso3166Alpha2\"\n      (ngModelChange)=\"change($event)\"\n      [disabled]=\"!editable\"\n    >\n      <option [ngValue]=\"null\">{{ defaultLabel }}</option>\n      <option *ngFor=\"let country of items\" [ngValue]=\"country.value\">{{ country.display }}</option>\n    </select>\n  "
                    }]
            }], function () { return [{ type: i0__namespace.ChangeDetectorRef }, { type: i0__namespace.ElementRef }, { type: i0__namespace.Renderer2 }, { type: I18nCountrySelectService }]; }, { name: [{
                    type: i0.Input
                }], iso3166Alpha2: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], pleaseChoose: [{
                    type: i0.Input
                }], editable: [{
                    type: i0.Input
                }], mandatory: [{
                    type: i0.Input
                }], iso3166Alpha2Change: [{
                    type: i0.Output
                }] });
    })();

    function CountrySelectComponent_option_3_Template(rf, ctx) {
        if (rf & 1) {
            i0__namespace.ɵɵelementStart(0, "option", 3);
            i0__namespace.ɵɵtext(1);
            i0__namespace.ɵɵelementEnd();
        }
        if (rf & 2) {
            var country_r1 = ctx.$implicit;
            i0__namespace.ɵɵproperty("value", country_r1.value);
            i0__namespace.ɵɵadvance(1);
            i0__namespace.ɵɵtextInterpolate(country_r1.display);
        }
    }
    var CountrySelectComponent = /** @class */ (function () {
        function CountrySelectComponent(service) {
            this.service = service;
            this.pleaseChoose = 'Please choose...';
            this.readonly = false;
            this.disabled = false;
            this.items = [];
            this.onChange = function (value) { };
            this.onTouched = function () { };
            this.touched = false;
            this.items = this.service.loadCountries();
        }
        Object.defineProperty(CountrySelectComponent.prototype, "additionalItems", {
            set: function (items) {
                this.items = __spreadArray(__spreadArray([], __read(items)), __read(this.items));
            },
            enumerable: false,
            configurable: true
        });
        ;
        CountrySelectComponent.prototype.change = function ($event) {
            this.value = $event;
            this.markAsTouched();
            this.onChange(this.value);
        };
        CountrySelectComponent.prototype.onAdd = function () {
            this.markAsTouched();
            if (!this.disabled) {
                this.onChange(this.value);
            }
        };
        CountrySelectComponent.prototype.onRemove = function () {
            this.markAsTouched();
            if (!this.disabled) {
                this.onChange(this.value);
            }
        };
        CountrySelectComponent.prototype.writeValue = function (value) {
            this.value = value;
        };
        CountrySelectComponent.prototype.registerOnChange = function (onChange) {
            this.onChange = onChange;
        };
        CountrySelectComponent.prototype.registerOnTouched = function (onTouched) {
            this.onTouched = onTouched;
        };
        CountrySelectComponent.prototype.markAsTouched = function () {
            if (!this.touched) {
                this.onTouched();
                this.touched = true;
            }
        };
        CountrySelectComponent.prototype.setDisabledState = function (disabled) {
            this.disabled = disabled;
        };
        return CountrySelectComponent;
    }());
    CountrySelectComponent.ɵfac = function CountrySelectComponent_Factory(t) { return new (t || CountrySelectComponent)(i0__namespace.ɵɵdirectiveInject(I18nCountrySelectService)); };
    CountrySelectComponent.ɵcmp = /*@__PURE__*/ i0__namespace.ɵɵdefineComponent({ type: CountrySelectComponent, selectors: [["country-select"]], inputs: { name: "name", cssClass: "cssClass", value: "value", pleaseChoose: "pleaseChoose", readonly: "readonly", disabled: "disabled", additionalItems: "additionalItems" }, features: [i0__namespace.ɵɵProvidersFeature([
                {
                    provide: i2.NG_VALUE_ACCESSOR,
                    multi: true,
                    useExisting: CountrySelectComponent,
                },
            ])], decls: 4, vars: 11, consts: [[3, "name", "id", "ngModel", "disabled", "ngModelChange"], ["disabled", "", 3, "value"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"]], template: function CountrySelectComponent_Template(rf, ctx) {
            if (rf & 1) {
                i0__namespace.ɵɵelementStart(0, "select", 0);
                i0__namespace.ɵɵlistener("ngModelChange", function CountrySelectComponent_Template_select_ngModelChange_0_listener($event) { return ctx.change($event); });
                i0__namespace.ɵɵelementStart(1, "option", 1);
                i0__namespace.ɵɵtext(2);
                i0__namespace.ɵɵelementEnd();
                i0__namespace.ɵɵtemplate(3, CountrySelectComponent_option_3_Template, 2, 2, "option", 2);
                i0__namespace.ɵɵelementEnd();
            }
            if (rf & 2) {
                i0__namespace.ɵɵclassMap(ctx.cssClass);
                i0__namespace.ɵɵproperty("name", ctx.name)("id", ctx.name)("ngModel", ctx.value)("disabled", ctx.disabled);
                i0__namespace.ɵɵattribute("readonly", ctx.readonly)("aria-readonly", ctx.readonly);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("value", null);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵtextInterpolate(ctx.pleaseChoose);
                i0__namespace.ɵɵadvance(1);
                i0__namespace.ɵɵproperty("ngForOf", ctx.items);
            }
        }, directives: [i2__namespace.SelectControlValueAccessor, i2__namespace.NgControlStatus, i2__namespace.NgModel, i2__namespace.NgSelectOption, i2__namespace.ɵNgSelectMultipleOption, i3__namespace.NgForOf], encapsulation: 2 });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(CountrySelectComponent, [{
                type: i0.Component,
                args: [{
                        // eslint-disable-next-line @angular-eslint/component-selector
                        selector: 'country-select',
                        template: " <select\n    [name]=\"name\"\n    [id]=\"name\"\n    [class]=\"cssClass\"\n    [ngModel]=\"value\"\n    (ngModelChange)=\"change($event)\"\n    [disabled]=\"disabled\"\n    [attr.readonly]=\"readonly\"\n    [attr.aria-readonly]=\"readonly\"\n  >\n    <option [value]=\"null\" disabled>{{ pleaseChoose }}</option>\n    <option *ngFor=\"let country of items\" [value]=\"country.value\">{{ country.display }}</option>\n  </select>",
                        providers: [
                            {
                                provide: i2.NG_VALUE_ACCESSOR,
                                multi: true,
                                useExisting: CountrySelectComponent,
                            },
                        ],
                    }]
            }], function () { return [{ type: I18nCountrySelectService }]; }, { name: [{
                    type: i0.Input
                }], cssClass: [{
                    type: i0.Input
                }], value: [{
                    type: i0.Input
                }], pleaseChoose: [{
                    type: i0.Input
                }], readonly: [{
                    type: i0.Input
                }], disabled: [{
                    type: i0.Input
                }], additionalItems: [{
                    type: i0.Input
                }] });
    })();

    var I18nCountrySelectModule = /** @class */ (function () {
        function I18nCountrySelectModule() {
        }
        I18nCountrySelectModule.forRoot = function () {
            return {
                ngModule: I18nCountrySelectModule,
            };
        };
        return I18nCountrySelectModule;
    }());
    I18nCountrySelectModule.ɵfac = function I18nCountrySelectModule_Factory(t) { return new (t || I18nCountrySelectModule)(); };
    I18nCountrySelectModule.ɵmod = /*@__PURE__*/ i0__namespace.ɵɵdefineNgModule({ type: I18nCountrySelectModule });
    I18nCountrySelectModule.ɵinj = /*@__PURE__*/ i0__namespace.ɵɵdefineInjector({ providers: [], imports: [[i3.CommonModule, i2.FormsModule]] });
    (function () {
        (typeof ngDevMode === "undefined" || ngDevMode) && i0__namespace.ɵsetClassMetadata(I18nCountrySelectModule, [{
                type: i0.NgModule,
                args: [{
                        declarations: [I18nCountrySelectComponent, CountrySelectComponent],
                        imports: [i3.CommonModule, i2.FormsModule],
                        providers: [],
                        exports: [I18nCountrySelectComponent, CountrySelectComponent],
                    }]
            }], null, null);
    })();
    (function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0__namespace.ɵɵsetNgModuleScope(I18nCountrySelectModule, { declarations: [I18nCountrySelectComponent, CountrySelectComponent], imports: [i3.CommonModule, i2.FormsModule], exports: [I18nCountrySelectComponent, CountrySelectComponent] }); })();

    /*
     * Public API Surface of ngx-i18n-country-select
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CountrySelectComponent = CountrySelectComponent;
    exports.I18nCountrySelectComponent = I18nCountrySelectComponent;
    exports.I18nCountrySelectModule = I18nCountrySelectModule;
    exports.I18nCountrySelectService = I18nCountrySelectService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-i18n-country-select.umd.js.map
