import { ControlValueAccessor } from '@angular/forms';
import { I18nCountrySelectService, IOption } from './i18n-country-select.service';
import * as i0 from "@angular/core";
export declare class CountrySelectComponent implements ControlValueAccessor {
    private service;
    name: string;
    cssClass: string;
    value: string;
    pleaseChoose: string;
    readonly: boolean;
    disabled: boolean;
    set additionalItems(items: any);
    items: IOption[];
    onChange: (value: any) => void;
    onTouched: () => void;
    touched: boolean;
    constructor(service: I18nCountrySelectService);
    change($event?: string): void;
    onAdd(): void;
    onRemove(): void;
    writeValue(value: string): void;
    registerOnChange(onChange: any): void;
    registerOnTouched(onTouched: any): void;
    markAsTouched(): void;
    setDisabledState(disabled: boolean): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CountrySelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CountrySelectComponent, "country-select", never, { "name": "name"; "cssClass": "cssClass"; "value": "value"; "pleaseChoose": "pleaseChoose"; "readonly": "readonly"; "disabled": "disabled"; "additionalItems": "additionalItems"; }, {}, never, never>;
}
//# sourceMappingURL=country-select.component.d.ts.map