import { AfterViewChecked, ChangeDetectorRef, EventEmitter, ElementRef, Renderer2 } from '@angular/core';
import { IOption, I18nCountrySelectService } from './i18n-country-select.service';
import * as i0 from "@angular/core";
export declare class I18nCountrySelectComponent implements AfterViewChecked {
    private cdRef;
    private el;
    private renderer;
    private service;
    defaultLabel: string;
    name: string;
    iso3166Alpha2: string;
    size: 'sm' | 'lg';
    pleaseChoose: string;
    editable: boolean;
    mandatory: boolean;
    iso3166Alpha2Change: EventEmitter<any>;
    items: IOption[];
    constructor(cdRef: ChangeDetectorRef, el: ElementRef, renderer: Renderer2, service: I18nCountrySelectService);
    change(newValue: string): void;
    ngAfterViewChecked(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<I18nCountrySelectComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<I18nCountrySelectComponent, "i18n-country-select", never, { "name": "name"; "iso3166Alpha2": "iso3166Alpha2"; "size": "size"; "pleaseChoose": "pleaseChoose"; "editable": "editable"; "mandatory": "mandatory"; }, { "iso3166Alpha2Change": "iso3166Alpha2Change"; }, never, never>;
}
//# sourceMappingURL=i18n-country-select.component.d.ts.map