import { ErrorHandler } from '@angular/core';
import * as i0 from "@angular/core";
export interface IOption {
    display: string;
    value: string;
}
export declare class I18nCountrySelectService {
    private localeId;
    private errorHandler;
    localeIds: string[];
    constructor(localeId: string, errorHandler: ErrorHandler);
    use(localeIds: string[]): Promise<void>;
    loadCountries(): IOption[];
    getLocale(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<I18nCountrySelectService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<I18nCountrySelectService>;
}
//# sourceMappingURL=i18n-country-select.service.d.ts.map